def tipNumeric = 'Number'
def tipString = 'String'
def file=files['reteteArtServ']
if(file==null){
  throw new RuntimeException("No upload file")
}

def locale = "ro";
def sdf="dd/MM/yyyy"

def fieldsBom=jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "bomQueryBuilder","getColumnLabels",[locale]).remoteSimpleObject;
def fieldsBomItems=jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "bomItemsQueryBuilder","getColumnLabels",[locale]).remoteSimpleObject;
def fieldsFisetehno=jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "fisetehnoQueryBuilder","getColumnLabels",[locale]).remoteSimpleObject;
def fieldsOpertehno=jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "opertehnoQueryBuilder","getColumnLabels",[locale]).remoteSimpleObject;


def cloneWb=null;
def cloneSheet=null
def suntErr=false;
def style=null;
def excCodBomList=[]
def bomObjMap=[:]
def fisaObjMap=[:]
def returnRowObjBom
def inreg=0

def secvop

try{
  excelReader.iterateRow(file, 1,true, {reader->
      int rowNo=reader.rowNo
      String sheetName=reader.sheetName
      
      println("excelReader.iterateRow --> rowNo: ${rowNo}")
      
      if(cloneSheet==null){
        cloneWb= reader.cloneWorkBook();
        cloneSheet=cloneWb.getSheet(sheetName)
        style=cloneWb.createCellStyle();
        style.setBorderBottom(BorderStyle.MEDIUM);
        style.setBottomBorderColor(IndexedColors.RED.getIndex());
        style.setBorderLeft(BorderStyle.MEDIUM);
        style.setLeftBorderColor(IndexedColors.RED.getIndex());
        style.setBorderRight(BorderStyle.MEDIUM);
        style.setRightBorderColor(IndexedColors.RED.getIndex());
        style.setBorderTop(BorderStyle.MEDIUM);
        style.setTopBorderColor(IndexedColors.RED.getIndex());
      }
       
      def rowContext=[:]
      def rowFieldContext=[:]
      
      
      def completeazaMap = {String numeColoanaXLS, String fieldEmsys, String dataType, int nrZec = 0 ->
        def  poz=reader.findPosition(numeColoanaXLS);
        def clonedRow=cloneSheet.getRow(rowNo);
        def val = null
        def errorGetVal = null
        def msgErrorGetVal = null

        switch(dataType) {
         case tipNumeric:
          try {
             val = reader.getNumber(numeColoanaXLS)
             if (val != null) {
                val = new BigDecimal(val).setScale(nrZec, BigDecimal.ROUND_HALF_UP)
             }
          } catch (error) {
             errorGetVal = error
          }
          break

         case tipString:
          try {
             val = reader.getString(numeColoanaXLS)
          } catch (error) {
             errorGetVal = error
          }
          break

         default:
          break
        }
        
        def content=['cell':poz,'field':fieldEmsys,'xlsField':numeColoanaXLS,'value':val,'poiCell':clonedRow.getCell(poz)]
        rowContext.put(numeColoanaXLS,content)
        rowFieldContext.put(fieldEmsys,content)
        return  content;
      }
      
      
      def sectie=completeazaMap("Sectie", 'sectie', tipString)
      def tipReper=completeazaMap("Tip produs", 'tipReper', tipString)
      def codBom=completeazaMap("Cod Produs(reteta)", 'codBom', tipString)
      def tipReperfiu=completeazaMap("Componenta", 'tipReperfiu', tipString)
      def codartservFiu=completeazaMap("Cod", 'codartservFiu', tipString)
      def qreperfiuBrut=completeazaMap("cantitate/um", 'qreperfiuBrut', tipNumeric, 6)
      def operatia=completeazaMap("Operatia", 'codop', tipString)
      def denop=completeazaMap("Denumire operatie", 'denop', tipString)
      def atelier=completeazaMap("Atelier", 'atelier', tipString)
      def postlucru=completeazaMap("Post Lucru", 'postlucru', tipString)
      

      if (sectie.value==null && tipReper.value==null && codBom.value==null && tipReperfiu.value==null 
        && codartservFiu.value==null && qreperfiuBrut.value==null && operatia.value==null){
        return;
      }
      
      inreg++;
      
      
      Calendar cal = Calendar.getInstance();
      cal.setTime(new Date()); 
      cal.set(Calendar.DAY_OF_YEAR, 1);    
	  cal.set(Calendar.HOUR_OF_DAY, 0);
	  cal.set(Calendar.MINUTE, 0);
	  cal.set(Calendar.SECOND, 0);
	  cal.set(Calendar.MILLISECOND, 0);
	  
      def datainc = cal.getTime();
      cal.set(Calendar.MONTH, 11);
      cal.set(Calendar.DAY_OF_MONTH, 31);
      cal.set(Calendar.YEAR, 2999);
      def datasf = cal.getTime();
       
      def okDet = true;
      def nrErr = 0;
      def msgs=new StringBuilder()
      
      def flagCodBom=false
      if(bomObjMap.get(codBom.value)!=null) {
        
        if (sectie.value==null){
          flagCodBom=true;
        } else if (bomObjMap.get(codBom.value).sectie!=sectie.value){
          flagCodBom=true;  
        }
        if (tipReper.value==null){
          flagCodBom=true;
        } else if (bomObjMap.get(codBom.value).tipReper!=tipReper.value){
          flagCodBom=true; 
        }
      }
      
      
      
      if (!excCodBomList.contains(codBom.value) || flagCodBom) {
        
        secvop = 10
        
        def returnTemplate=null;
        if ("ARTICOL".equals(tipReper.value)){
          returnTemplate = jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomService", "findNomRow", [codBom.value, idFirma])
        } else if ("SERVICIU".equals(tipReper.value)){
          returnTemplate = jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomServService", "findNomServRow", [codBom.value, idFirma])
        }

        def codum=null, denBom=null;
        if (returnTemplate!=null){
          if (returnTemplate.remoteSimpleObject!=null){
            if ("ARTICOL".equals(tipReper.value)){
              codum=returnTemplate.remoteSimpleObject.codUm
              denBom=returnTemplate.remoteSimpleObject.numeart
            } else if ("SERVICIU".equals(tipReper.value)){
              codum=returnTemplate.remoteSimpleObject.codum
              denBom=returnTemplate.remoteSimpleObject.numeserv
            }
          }
        }
        
        def mapFisa=[
          'idFirma': idFirma,
          'idUserAct': idUser,
          'codFisatehno': codBom.value,
          'denFisatehno': denBom,
          'stareT': "V_TEHNOLOG",
          'stareN': "V_NORMATOR",
          'dataAct': new Date(),
          'tipReper': tipReper.value,
          'sectie': sectie.value,
          'datainc': datainc,
          'datasf': datasf,
          'codartserv': codBom.value,
		  'idVerificatort': idUser,
		  'idTehnolog' : idUser,
		  'datavert' : new Date(),
		  'datateh': new Date()
        ]
        
        def returnObjFisa=jsonRemotingService.invokeRemote("EMSYS_LOGISTICS", "fisetehnoService","insert",[locale, mapFisa]);
        def returnRowObjFisa=returnObjFisa.remoteRowObject
        
        println("after Fisa insert returnRowObjFisa= ${returnRowObjFisa}")
        println("returnObjFisa = ${returnObjFisa}")
      
        println "the object is successInvocation ::: "+returnObjFisa.successInvocation; 
        println "the object errorDetail ::: "+returnObjFisa.errorDetail; 
        println "the object errorMessage ::: "+returnObjFisa.errorMessage; 
        println "the object jsonReturnValue ::: "+returnObjFisa.jsonReturnValue;
        
        if (returnRowObjFisa!=null){
          if (returnRowObjFisa.containsErrors()) {
            
            suntErr=true;
            okDet=false;
            
            returnRowObjFisa.messageList.each{emsMgs->
              
              nrErr++;
              
              if(emsMgs.field==null){
                msgs<<"(FisaTeh) ${emsMgs.message} \n"

              } else{
                def rowCtx = rowFieldContext[emsMgs.field];
                def field = fieldsFisetehno[emsMgs.field];
                
                if (rowCtx!=null) {      
                  def pocell=rowCtx.poiCell
                  if (pocell!=null){
                    pocell.setCellStyle(style);
                  }
                  
                  msgs<<"${rowCtx.xlsField}: ${emsMgs.message}; \n"
                } else {
                  msgs<<"${field}(FisaTeh): ${emsMgs.message}; \n" 
                }
              }
            }
            
          } else {
            if (!fisaObjMap.containsKey(codBom.value)) {
              fisaObjMap.put(codBom.value, returnRowObjFisa.values.idFisatehno)
            }
          }
        }
          
        
        def codFisatehno=null
        if (returnRowObjFisa!=null){
          codFisatehno=returnRowObjFisa.values.codFisatehno
        }
        
        def mapBom=[
          'idFirma' : idFirma,
          'idUserAct' : idUser,
          'dataAct' : new Date(),
          'codBom' : codBom.value,
          'codartserv' : codBom.value,
          'denBom' : denBom,
          'tipReper' : tipReper.value,
          'codum' : codum,
          'sectie': sectie.value,
          'procplan': 100,
          'lreteta': 0,
          'datainc': datainc,
          'datasf': datasf,
          'datateh': datainc,
          'stareT': "V_TEHNOLOG",
          'lprincipal': 1,
          'codFisatehno': codFisatehno,
		  'lotordEgalLotcomp':'NU'
        ]
        def argsBom=[locale,mapBom, sdf, new Date()];
        
        def returnObjBom=jsonRemotingService.invokeRemote("EMSYS_LOGISTICS", "bomService","insert",argsBom);
        returnRowObjBom = returnObjBom.remoteRowObject

        println("after bom insert returnRowObjBom= ${returnRowObjBom}")
        println("returnObjBom = ${returnObjBom}")
      
        println "the object is successInvocation ::: "+returnObjBom.successInvocation; 
        println "the object errorDetail ::: "+returnObjBom.errorDetail; 
        println "the object errorMessage ::: "+returnObjBom.errorMessage; 
        println "the object jsonReturnValue ::: "+returnObjBom.jsonReturnValue;
        
        
        if(returnRowObjBom!=null){
          
          if (sectie.value==null){
            returnRowObjBom.addMessage(EmsysMessage.ERROR_MESSAGE, "Valoare obligatorie! \n", null, "sectie");
          }
          if (tipReper.value==null){
            returnRowObjBom.addMessage(EmsysMessage.ERROR_MESSAGE, "Valoare obligatorie! \n", null, "tipReper");  
          }
          if (returnRowObjBom.containsErrors()) {

            suntErr=true;
            okDet=false;

            returnRowObjBom.messageList.each{emsMgs->

              nrErr++;
              
              if(emsMgs.field==null){
                msgs<<"${emsMgs.message} \n"

              }else{
                def rowCtx = rowFieldContext[emsMgs.field];
                def field = fieldsBom[emsMgs.field];
                
                if (rowCtx!=null) {
                  
                  def pocell=rowCtx.poiCell
                  if (pocell!=null){
                    pocell.setCellStyle(style);
                  }
                  
                  msgs<<"${rowCtx.xlsField}: ${emsMgs.message}; \n"
                } else {
                  
                  if (emsMgs.field=="codum" || emsMgs.field=="denBom"){
                    
                    if ("ARTICOL".equals(tipReper.value)){
                      msgs<<"${field} Articol: ${emsMgs.message}; \n"
                      
                    } else if ("SERVICIU".equals(tipReper.value)){
                      msgs<<"${field} Serviciu: ${emsMgs.message}; \n"
                      
                    } else {
                      msgs<<"${field}: ${emsMgs.message}; \n"  
                    }
                    
                  } else if (emsMgs.field=="codartserv" || emsMgs.field=="codArtServ"){//de scos ulterior codArtServ

                    rowCtx = rowFieldContext["codBom"]
                    msgs<<"${rowCtx.xlsField}: ${emsMgs.message}; \n"
                    def pocell=rowCtx.poiCell
                    if (pocell!=null){
                      pocell.setCellStyle(style);
                    }
                    
                  } else {
                    msgs<<"${field}: ${emsMgs.message}; \n"
                  }
                }
              }
            }
            
            println("returnRowObjBom.messageList ${returnRowObjBom.messageList}")
            
         
            if (returnRowObjFisa!=null){
              if (!returnRowObjFisa.containsErrors()) {
                def returnObjFisaDel=jsonRemotingService.invokeRemote("EMSYS_LOGISTICS", "fisetehnoService","delete",[locale, returnRowObjFisa.values]);
                println" se sterge fisa tehno cu codul ${codBom.value}"
                println "the object is successInvocation ::: "+returnObjFisaDel.successInvocation; 
                println "the object errorDetail ::: "+returnObjFisaDel.errorDetail; 
                println "the object errorMessage ::: "+returnObjFisaDel.errorMessage; 
                println "the object jsonReturnValue ::: "+returnObjFisaDel.jsonReturnValue;
              }
            }
            
            
            
          } else {
            if (!excCodBomList.contains(codBom.value)) {
              excCodBomList.add(codBom.value)
            }
            if (!bomObjMap.containsKey(codBom.value)) {
              bomObjMap.put(codBom.value, ['idFirma': idFirma, 'idUserAct': idUser, 'idBom': returnRowObjBom.values.idBom,
                'sectie': sectie.value, 'tipReper': tipReper.value, 'idSectie': returnRowObjBom.values.idSectie, 'codum': returnRowObjBom.values.codum])
            }
          }
        }
      }
      
      
      
      if (okDet){
        
        def flagAmOper=false
        
        sql.eachRow("SELECT CASE WHEN EXISTS (SELECT ID_FIRMA FROM TOTAL.OPERTEHNO OPERTEHNO WHERE ID_FIRMA=:ID_FIRMA AND ID_FISATEHNO=:ID_FISATEHNO AND CODOP=:CODOP) THEN 1 ELSE 0 END AM_CODOP FROM DUAL",
          ["ID_FIRMA": idFirma, "ID_FISATEHNO": fisaObjMap.get(codBom.value), "CODOP": operatia.value])	{rw ->		
          if(rw!=null){
            if (rw.AM_CODOP==1) {
              flagAmOper=true
            }
          }
        }
        

        if(!flagAmOper){
          
//          def denOper=denop.value
//          if (denOper==null){
//            def returnTemplate=null;
//            if ("ARTICOL".equals(tipReper.value)){
//              returnTemplate = jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomService", "findNomRow", [codBom.value, idFirma])
//            } else if ("SERVICIU".equals(tipReper.value)){
//              returnTemplate = jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomServService", "findNomServRow", [codBom.value, idFirma])
//            }
//            if (returnTemplate!=null){
//              if (returnTemplate.remoteSimpleObject!=null){
//                if ("ARTICOL".equals(tipReper.value)){
//                  denOper=returnTemplate.remoteSimpleObject.numeart
//                } else if ("SERVICIU".equals(tipReper.value)){
//                  denOper=returnTemplate.remoteSimpleObject.numeserv
//                }
////                cloneSheet.getRow(rowNo).getCell(7).setCellValue(denOper)
//              }
//            }
//          }
          
          def mapOper=[
            'idFirma': idFirma,
            'idUserAct': idUser,
            'idFisatehno': fisaObjMap.get(codBom.value),
            'secvop' : secvop,
            'nrop' : 1,
            'tipop' : "P",
            'stareop' : "DESCHISA",
            'codop' : operatia.value,
            'denop' : denop.value,
            'procesare' : 'INT', 
			'randament':100,
            'datainc' : datainc,
            'datasf' : datasf,
            'nrmuncitori' : 0,           
            'tQueue' : 0,
            'lpayQueue' : 0, 
            'tsetup' : 0,
            'lpaySetup' : 0, 
            'trun' : 0, 
            'lpayRun' : 0, 
            'twait' : 0, 
            'lpayWait' : 0, 
            'tmove' : 0, 
            'lpayMove' : 0,	            
            'qlotext' : 0,
            'sporprocent' : 0,
            'sporsuma' : 0,
            'dataAct': new Date(),
            'nrmuncitori': 1,
            'atelier': atelier.value,
            'postlucru': postlucru.value,
            'idSectie': bomObjMap.get(codBom.value).idSectie,
			'codumTimpint': bomObjMap.get(codBom.value).codum
          ]

          def returnObjOper=jsonRemotingService.invokeRemote("EMSYS_LOGISTICS", "opertehnoService","insert",[locale, mapOper, sdf, new Date()]);
          def returnRowObjOper=returnObjOper.remoteRowObject

          println("after Oper insert returnRowObjOper= ${returnRowObjOper}")
          println("returnObjOper = ${returnObjOper}")

          println "the object is successInvocation ::: "+returnObjOper.successInvocation; 
          println "the object errorDetail ::: "+returnObjOper.errorDetail; 
          println "the object errorMessage ::: "+returnObjOper.errorMessage; 
          println "the object jsonReturnValue ::: "+returnObjOper.jsonReturnValue;

          if (returnRowObjOper!=null){
            if (returnRowObjOper.containsErrors()) {

              suntErr=true;

              returnRowObjOper.messageList.each{emsMgs->

                nrErr++;

                if(emsMgs.field==null){
                  msgs<<"(OperTeh) ${emsMgs.message}; \n"

                } else{
                  def rowCtx = rowFieldContext[emsMgs.field];
                  def field = fieldsOpertehno[emsMgs.field];

                  if (rowCtx!=null) {      
                    def pocell=rowCtx.poiCell
                    if (pocell!=null){
                      pocell.setCellStyle(style);
                    }

                    msgs<<"${rowCtx.xlsField}: ${emsMgs.message}; \n"
                  } else {
                    msgs<<"${field}(OperTeh): ${emsMgs.message}; \n" 
                  }
                }
              }
            }
          }
        } else {
//          sql.eachRow("SELECT DENOP FROM TOTAL.OPERTEHNO OPERTEHNO WHERE ID_FIRMA=:ID_FIRMA AND ID_FISATEHNO=:ID_FISATEHNO AND CODOP=:CODOP",
//            ["ID_FIRMA": idFirma, "ID_FISATEHNO": fisaObjMap.get(codBom.value), "CODOP": operatia.value])	{rw ->		
//            if(rw!=null){
//              cloneSheet.getRow(rowNo).getCell(7).setCellValue(rw.denop)
//            }
//          }
        }
        
//        def cantitate=null;
//        if (qreperfiuBrut.value!=null){
//          cantitate = new BigDecimal(qreperfiuBrut.value).setScale(6, BigDecimal.ROUND_HALF_EVEN)
//        }
        
        def returnTemplate=null;
        if ("ARTICOL".equals(tipReper.value)){
          returnTemplate = jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomService", "findNomRow", [codBom.value, idFirma])
        } else if ("SERVICIU".equals(tipReper.value)){
          returnTemplate = jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomServService", "findNomServRow", [codBom.value, idFirma])
        }

        def codumBom=null, codumBomIt=null

        if (returnTemplate!=null){
          if (returnTemplate.remoteSimpleObject!=null){
            if ("ARTICOL".equals(tipReper.value)){
              codumBom=returnTemplate.remoteSimpleObject.codUm
            } else if ("SERVICIU".equals(tipReper.value)){
              codumBom=returnTemplate.remoteSimpleObject.codum
            }
          }
        }
        
        def returnTemplateIt=null
        if ("SERVICIU".equals(tipReperfiu.value)){
          returnTemplateIt = jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomServService", "findNomServRow", [codartservFiu.value, idFirma])
        } else {
          returnTemplateIt = jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomService", "findNomRow", [codartservFiu.value, idFirma])
        }
        if (returnTemplateIt!=null){
          if (returnTemplateIt.remoteSimpleObject!=null){
            if ("SERVICIU".equals(tipReperfiu.value)){
              codumBomIt=returnTemplateIt.remoteSimpleObject.codum
            } else {
              codumBomIt=returnTemplateIt.remoteSimpleObject.codUm
            }
          }
        }
		
		def bomitemsSecventa = null;
		def bomitemsNrop = null;
	    sql.eachRow(" SELECT SECVOP, NROP FROM TOTAL.OPERTEHNO OPERTEHNO WHERE ID_FIRMA=:ID_FIRMA AND ID_FISATEHNO=:ID_FISATEHNO AND CODOP=:CODOP ",
          ["ID_FIRMA": idFirma, "ID_FISATEHNO": fisaObjMap.get(codBom.value), "CODOP": operatia.value])	{rw ->		
          if(rw!=null){
             bomitemsSecventa= rw.SECVOP
			 bomitemsNrop = rw.NROP
          }
        }
        
        def mapBomItems=[
        'idFirma' : idFirma,
        'idUserAct' : idUser,
        'dataAct' : new Date(),
        'codBom' : codBom.value,
        'tipRepertata' : tipReper.value,
        'tipReperfiu' : tipReperfiu.value,
        'codumRepertata' : codumBom,
        'codumReperfiu' : codumBomIt,
        'optional': 0,
        'procrebut': 0,
        'procplan': 100,
        'qrepertata': 1,
        'qreperfiuNet': qreperfiuBrut.value,
        'qreperfiuBrut': qreperfiuBrut.value,    
        'datainc': datainc,
        'datasf': datasf,
        'fisalimita': "COPRODUS".equals(tipReperfiu.value) ? "NU" : "DA",
        'codartservFiu': codartservFiu.value,
        'idBom': returnRowObjBom.values.idBom,
		'idFisatehno':fisaObjMap.get(codBom.value),			
		'secvop' : bomitemsSecventa,
		'nrop' : bomitemsNrop,
		'postlucru': postlucru.value             	
        ]
        
        def argsBomItems=[locale,mapBomItems];
        def returnObjBomItems=jsonRemotingService.invokeRemote("EMSYS_LOGISTICS", "bomItemsService","insert",argsBomItems);
        returnRowObjBomItems = returnObjBomItems.remoteRowObject
        
        println("after BomItems insert returnRowObjBomItems= ${returnRowObjBomItems}")
        println("returnObjBomItems = ${returnObjBomItems}")
      
        println "the object is successInvocation ::: "+returnObjBomItems.successInvocation; 
        println "the object errorDetail ::: "+returnObjBomItems.errorDetail; 
        println "the object errorMessage ::: "+returnObjBomItems.errorMessage; 
        println "the object jsonReturnValue ::: "+returnObjBomItems.jsonReturnValue; 
        
        
        if(returnRowObjBomItems!=null){
          if (tipReperfiu.value==null){
            returnRowObjBomItems.addMessage(EmsysMessage.ERROR_MESSAGE, "Valoare obligatorie! \n", null, "tipReperfiu");
          }
          
          if(returnRowObjBomItems.containsErrors()) {
            
            suntErr=true;
            
            returnRowObjBomItems.messageList.each{emsMgs->
              nrErr++;
              if(emsMgs.field==null){
                msgs<<"${emsMgs.message} \n"

              }else{
                def rowCtx = rowFieldContext[emsMgs.field];
                def field = fieldsBomItems[emsMgs.field];
                
                                
                if (rowCtx!=null) {
                  
                  def pocell=rowCtx.poiCell
                  if (pocell!=null){
                    pocell.setCellStyle(style);
                  }
                  
                  msgs<<"${rowCtx.xlsField}: ${emsMgs.message}; \n"
                  
                } else {
                  
                  if (emsMgs.field!="qreperfiuNet"){
                    
                    msgs<<"${field}: ${emsMgs.message}; \n"
                  }
                }
              }
            }
            println"returnRowObjBomItems.messageList: ${returnRowObjBomItems.messageList}"
            
          }
        }
      
        if (returnRowObjBomItems==null){
          return;
        } 
      }
      if(nrErr > 0){ 
        def row=cloneSheet.getRow(rowNo);
        def cellNo=cloneSheet.getRow(0).getLastCellNum()
        row.createCell(cellNo).setCellValue(msgs.toString().substring(0, msgs.length()-1))
        
        if (nrErr>1) {
          nrErr<=10 ? row.setHeightInPoints((float)(row.getHeightInPoints() * nrErr)): row.setHeightInPoints((float)(row.getHeightInPoints() * 10))
        }
      }
      
      secvop+=10;
    });
  
  cloneSheet.autoSizeColumn(cloneSheet.getRow(0).getLastCellNum(), false)
  cloneSheet.getRow(0).createCell(cloneSheet.getRow(0).getLastCellNum()).setCellValue("Erori")
  
  if (!bomObjMap.isEmpty() && suntErr){
    bomObjMap.each {bom-> 
      println("se sterge bom-ul cu codul ${bom.key} si ${bom.value}")
      
      def returnObjDel=jsonRemotingService.invokeRemote("EMSYS_LOGISTICS", "bomService","delete",[locale, bom.value]);

      println "the object is successInvocation ::: "+returnObjDel.successInvocation; 
      println "the object errorDetail ::: "+returnObjDel.errorDetail; 
      println "the object errorMessage ::: "+returnObjDel.errorMessage; 
      println "the object jsonReturnValue ::: "+returnObjDel.jsonReturnValue;
    }
  }
  if (!fisaObjMap.isEmpty() && suntErr){
    fisaObjMap.each {fisa-> 
      println("se sterge fisa tehno cu cod ${fisa.key} si id ${fisa.value}")
      def argsDel = ['idFirma': idFirma, 'idUserAct': idUser, 'idFisatehno': fisa.value]
      def returnObjDel=jsonRemotingService.invokeRemote("EMSYS_LOGISTICS", "fisetehnoService","delete",[locale, argsDel]);

      println "the object is successInvocation ::: "+returnObjDel.successInvocation; 
      println "the object errorDetail ::: "+returnObjDel.errorDetail; 
      println "the object errorMessage ::: "+returnObjDel.errorMessage; 
      println "the object jsonReturnValue ::: "+returnObjDel.jsonReturnValue;
    }
  }
  
  File fn = new File(tmpFolder, "temp.txt")
  fn.createNewFile()
  if(!suntErr){
    fn.text = "<html><body><div>Operatia s-a realizat cu succes! ${inreg} randuri au fost adaugate</div></body></html>"
    attachFile("Info.html", fn)
    
  }else{
    fn.text = "<html><body><div>In urma operatiei, ${inreg} randuri sunt necorespunzatoare/au erori. </div></body></html>"
    attachFile("Info.html", fn)
    File fisXLS=new File(tmpFolder,'temp.xlsx');
    fisXLS.withOutputStream{os->
      cloneWb.write(os)
    }
    attachFile("Erori.xlsx",fisXLS)
  }
}catch(Exception e){
  throw new RuntimeException(e);
}

public void generateFieldDefinition(Locale locale ,ErpGroovyTemplatesService.Definition definition ){
  definition.addUploadField('reteteArtServ','Fisier XLS').setOrder(20);
}
import org.apache.poi.ss.usermodel.IndexedColors;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.BorderStyle;
import org.apache.poi.ss.usermodel.FillPatternType;  
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import java.util.Calendar;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import com.prodinf.core.dataset.EmsysMessage;